module Frigate
	module Form
		# Serves for synchronization form properties with model attributes/properties
		module Synchronizer
			# Base class for Frigate::Form::Base synchronizations
			# It justs abstract class which has two methods
			# * sync form with model
			# * sync properties errors into form errors
			class Base < Fundamental
				# synchronizes form with model
				def sync_with_model
					raise NotImplementedError
				end

				# synchronizes form properties (associations:properties) errors with general form errors
				def sync_errors
					raise NotImplementedError
				end
			end
		end
	end
end