module Frigate
	module Form
		# Serves for synchronization form properties with model attributes/properties
		module Synchronizer
			# Synchronizes form properties with given params
			class Form < Basic
				# It's just extracted method *sync_properties_with_model_or_params* into this class
				class ParamsToPropertiesSynchronizer < Fundamental
					# Synchronizes given params with form properties and associations:properties
					# @param [Hash] params
					def sync_params_with_properties(params)
						process_params(params, form)
					end

					private

					def process_params(params, ctx)
						params.each do |_p_n, _p_v|
							if _p_v.is_a?(Hash)
								process_params(_p_v, ctx.send(_p_n.to_sym))
							else
								sync_properties(_p_n, _p_v, ctx)
							end
						end
					end

					def sync_properties(p_n, p_v, ctx)
						ctx.properties.each { |_p| _p.value = p_v if p_n.to_sym == _p.name.to_sym }
					end
				end

				# Synchronizes given params with form properties and associations:properties
				# @param [Hash] params
				def sync_properties_with_model_or_params(params)
					ParamsToPropertiesSynchronizer.new(form).sync_params_with_properties(params)
				end
			end
		end
	end
end