# @example
# 	class Song::AddArtistService < Frigate::Service
# 		property :song
# 		property :artist
#
# 		def function
# 			song.artists << artist
# 		end
# 	end
#
# 	Song::AddArtistService[song: song, artist: artist]
class Frigate::Function
	class << self
		# @param [Symbol] name
		def property(name)
			class_eval { attr_reader name }
		end

		# @param [Hash] attrs
		def run(attrs)
			new(attrs).run
		end

		alias_method :[], :run
	end

	# @param [Hash] attrs
	def initialize(attrs)
		attrs.each { |key, val| instance_variable_set("@#{key}", val) }
	end

	# to perform/run the service actions\tasks
	def run
		function
	end

	#  here you should write your function code =)
	def function
		raise NotImplemented
	end
end